
# Taman luokan tarkoituksena on piirtaa pallo ja siihen tahtain.
# kun pelaaja klikkaa pallon jotakin kohtaa niin mailalla lyadaan siihen
# kohtaan

from Point import Point
import math
import gtk

class Sight :   

   def __init__(self, x, y) :

      self.ball_radius = 15
      self.ball_point = Point(x, y)
      self.sight_point = Point(x, y)
      self.sight_x = 0
      self.sight_y = 0


   def draw(self, drawing_area) :

      graphics_context  = drawing_area.get_style().fg_gc[gtk.STATE_NORMAL]
      this_drawable  =  drawing_area.window

      graphics_context.set_rgb_fg_color(gtk.gdk.Color(56320, 56320, 56320, 0))

      this_drawable.draw_arc(graphics_context, True,
                             self.ball_point.x - self.ball_radius,
                             self.ball_point.y - self.ball_radius,
                             self.ball_radius * 2, self.ball_radius * 2,
                             0, 360*64 )

      graphics_context.set_rgb_fg_color(gtk.gdk.Color(0, 0, 0, 0))
      this_drawable.draw_arc(graphics_context, False,
                             self.ball_point.x - self.ball_radius,
                             self.ball_point.y - self.ball_radius,
                             self.ball_radius * 2, self.ball_radius * 2,
                             0, 360*64)

      this_drawable.draw_arc(graphics_context, False,
                             self.ball_point.x - 1, self.ball_point.y - 1, 2, 2,
                             0, 360*64)

      this_drawable.draw_line(graphics_context, self.sight_point.x - 5,
                              self.sight_point.y, self.sight_point.x + 5,
                              self.sight_point.y)

      this_drawable.draw_line(graphics_context, self.sight_point.x,
                              self.sight_point.y - 5, self.sight_point.x,
                              self.sight_point.y + 5)


   def contains_point(self, point) :

      if math.hypot(point.x - self.ball_point.x,
                    point.y - self.ball_point.y) < self.ball_radius :

         return True

      else  :

         return False

   def set_sight_point(self, point) :

      self.sight_point = point

      self.sight_x = self.sight_point.x - self.ball_point.x
      self.sight_y = self.ball_point.y - self.sight_point.y


   def get_sight_point(self) :

      return Point(self.sight_point.x - self.ball_point.x,
                   self.ball_point.y - self.sight_point.y)


